*
      SUBROUTINE CAZ_HEGVZ(IBTYPE, NAME, UPLO, N, NPROW, NPCOL, AMEM,
     $                     MEMSIZE, NB, VL, VU, IL, IU, ABSTOL, ORFAC,
     $                     INFILEA, INFILEB, OUTFILE)
*
*      (PZHEGV2, PZHEGV4, PZHEGV6)
*       
*   QL  QR - 
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, IL, IU, IBTYPE
      DOUBLE COMPLEX     AMEM( MEMSIZE )
      DOUBLE PRECISION   VL, VU, ABSTOL, ORFAC
      CHARACTER*(*)      INFILEA, INFILEB, OUTFILE, NAME, UPLO
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            ANB, CTXT, I, IAM, INFO, IPA, IPB, IFAIL,
     $                   IFAIL1, IFAIL2,
     $                   IPEV, IPGAP, IPFAIL, IPCLUSTR, IPW, IPWOR,
     $                   IPIWOR, IPRWOR, IPZ, NP, NQ, M, MYCOL, MYROW,
     $                   MXNP, MXNQ, MQ0, NEIG, NEX, NN, NZ, NP0, NQ0,
     $                   NHETRD_LWOPT, NHEGST_LWOPT, LWOPT, LWORK,
     $                   LIWORK, LRWORK,  IA, JA, IB, JB, IZ, JZ,
     $                   NPROCS, NPS, MMIN, SQNPC, WORKSIZ
*
      DOUBLE PRECISION   FAIL1, FAIL2
*  
      INTEGER            DESCA( 9 ), DESCB( 9 ), DESCZ( 9 )
      DOUBLE PRECISION   W(N)
*
*  
      EXTERNAL           ICEIL, NUMROC, PDLAMCH, PDLANGE,
     $                   PJLAENV
      INTEGER            ICEIL, NUMROC, PJLAENV
      DOUBLE PRECISION   PDLAMCH, PDLANGE
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZLAPRNT, PZLAREAD,
     $                   PZLAWRITE,
     $                   PZHEGV2, PZHEGV4, PZHEGV6
*
*  
      INTRINSIC          ABS, DBLE, MAX, MIN, MOD, SQRT, INT
*
*  
*
*  
*
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      IZ = 1
      JZ = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
*           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A, B  Z
*
      CALL DESCINIT(DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCB, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCZ, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*     B
      IPB = IPA + DESCA(9)*NQ
*
*     EV ( )
      IPEV = IPB + DESCB(9)*NQ
*
*     Z (  )
      IPZ = IPEV + N
*     WORK
*
      IPWOR = IPZ + DESCZ(9)*NQ
*
      NN = MAX( N, NB, 2 )
      NP0 = NUMROC( NN, NB, 0, 0, NPROW )
*
      NPROCS = NPROW*NPCOL
*
      IF( NAME .NE. 'PZHEGV4' .AND. NAME .NE. 'PZHEGV6' ) GOTO 2
*
      IPGAP = IPZ + DESCZ(9)*NQ
      IPFAIL = IPGAP + NPROW*NPCOL
      IPCLUSTR = IPFAIL + N
*     WORK
      IPWOR = IPCLUSTR + 2*NPROW*NPCOL
*
*   ,    PZHEGV2(4,6)
*
      LIWORK = 6*MAX( N, (NPROW*NPCOL) + 1, 4 )
*
      IF( NAME .NE. 'PZHEGV4' ) GOTO 1
*
        NEIG = N
        MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
        LWMIN = N + ( NP0+MQ0+NB )*NB
        LRWMIN = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $           ICEIL( NEIG, NPROW*NPCOL )*NN
        LRWOPT = LRWMIN
        LWOPT = LWMIN
*
      GO TO 7
*
    1 NEIG = IU - IL + 1
      MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
      LWMIN = N + ( NP0+MQ0+NB )*NB
      LRWMIN = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $         ICEIL( NEIG, NPROW*NPCOL )*NN
      LRWOPT = LRWMIN
      LWOPT = LWMIN
      GO TO 7
*
    2 IF( NAME .NE. 'PZHEGV2' ) GOTO 10
*
      NEIG = N
      MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
      LWOPT = N + ( NP0+MQ0+NB )*NB
      LRWOPT = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $         ICEIL( NEIG, NPROW*NPCOL )*NN
*
    7 ANB = PJLAENV( CTXT, 3, 'PZHETTRD', 'L', 0, 0, 0, 0 )
      SQNPC = INT( SQRT( DBLE( NPROW*NPCOL ) ) )
      NPS = MAX( NUMROC( N, 1, 0, 0, SQNPC ), 2*ANB )
      NHETRD_LWOPT = 2*( ANB+1 )*( 4*NPS+2 ) + ( NPS+4 )*NPS
**      NB = DESCA( MB_ )
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
      NQ0 = NUMROC( N, NB, 0, 0, NPCOL )
      NHEGST_LWOPT = 2*NP0*NB + NQ0*NB + NB*NB
      LWOPT = MAX( LWOPT, N+NHETRD_LWOPT, NHEGST_LWOPT )
*
      LWORK = LWOPT
      LRWORK = LRWOPT
*
      IF( NAME .NE. 'PZHEGV4' .AND. NAME .NE. 'PZHEGV6' ) GOTO 5
*
*     IWORK
      IPIWOR = IPWOR + LWORK
      IPRWOR = IPIWOR + LIWORK
      IPW = IPRWOR + LRWORK
*
      GOTO 3
*
    5 IPRWOR = IPWOR + LWORK
      IPW = IPRWOR + LRWORK
*
*     PZLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP0 )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
*
         WRITE( NPR, FMT = * )'IPA, IPB, IPEV, IPWOR,IPRWOR, IPW, MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPB, IPEV, IPWOR,IPRWOR, IPW,MMIN
*
         IF( NAME .NE. 'PZHEGV4' .AND. NAME .NE. 'PZHEGV6' ) GOTO 4
         WRITE( NPR, FMT = * )' IPZ   ANB   NPS LWORK LRWORK LIWORK'
         WRITE( NPR, FMT = 9994 ) IPZ, ANB, NPS, LWORK, LRWORK, LIWORK
    4    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCB'
         WRITE( NPR, FMT = 9985 )DESCB
         WRITE( NPR, FMT = * ) '  DESCZ'
         WRITE( NPR, FMT = 9985 )DESCZ
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
*        A  B
*
      CALL PZLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
*
      CALL PZLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PZLAREAD(INFILEB, AMEM(IPB), DESCB, 0, 0, AMEM(IPW))
*
 9994 FORMAT( / 7I5 /)
 9985 FORMAT( / 9I5 /)
*
      CALL PZLAPRNT( N, N, AMEM(IPB), IB, JB, DESCB, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*     
*
      IF( NAME .EQ. 'PZHEGV4' ) GOTO 12
      IF( NAME .EQ. 'PZHEGV6' ) GOTO 14
      IF( NAME .NE. 'PZHEGV2' ) GOTO 10
*
      CALL PZHEGV2( IBTYPE, UPLO, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPB), IB, JB, DESCB, W(1), AMEM(IPZ),
     $              IZ, JZ, DESCZ, AMEM(IPWOR), LWORK, AMEM(IPRWOR),
     $              LRWORK, IFAIL, INFO)
      GOTO 99
*
   14 CALL PZHEGV6( IBTYPE, UPLO, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPB), IB, JB, DESCB, IL, IU, ABSTOL, M, NZ,
     $              W(1), ORFAC, AMEM(IPZ), IZ, JZ, DESCZ,
     $              AMEM(IPWOR), LWORK, AMEM(IPRWOR), LRWORK,
     $              AMEM(IPIWOR), LIWORK, AMEM(IPFAIL), AMEM(IPCLUSTR),
     $              AMEM(IPGAP), INFO )
      GOTO 99
*
   12 CALL PZHEGV4( IBTYPE, UPLO, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPB), IB, JB, DESCB, VL, VU, ABSTOL, M, NZ,
     $              W(1), ORFAC, AMEM(IPZ), IZ, JZ, DESCZ,
     $              AMEM(IPWOR), LWORK, AMEM(IPRWOR), LRWORK,
     $              AMEM(IPIWOR), LIWORK, AMEM(IPFAIL), AMEM(IPCLUSTR),
     $              AMEM(IPGAP), INFO )
      GOTO 99
*
*  
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9995 )INFO, UPLO, IBTYPE
         WRITE( NPR, FMT = 9993 ) ABSTOL, ORFAC
       IF( NAME .NE. 'PZHEGV4' ) GOTO 15
         WRITE( NPR, FMT = 9991 ) VL, VU
   15  IF( NAME .NE. 'PZHEGV6' ) GOTO 16
         WRITE( NPR, FMT = 9989 ) IL, IU
   16  IF( NAME .NE. 'PZHEGV2' ) GOTO 29
         WRITE( NPR, FMT = 9999 ) IFAIL
         GO TO 17
   29    WRITE( NPR, FMT = 9990 ) M
         WRITE( NPR, FMT = 9988 ) NZ
*
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
*
   17   WRITE( NPR, FMT = * ) '  '
        NEX = N
        IF( NAME .EQ. 'PZHEGV2') GOTO 11
*
        NEX = M
   11    DO 18 I = 1, NEX
         PRINT *, ' W(', I, ')=', W( I ), ';'
   18   CONTINUE
*
        IF( NAME .EQ. 'PZHEGV2') GOTO 30
*
        WRITE( NPR, FMT = * )'   IFAIL'
        J = 1
        DO 8 I = IPFAIL, IPFAIL+N/2-1, 1
        FAIL1 = REAL(AMEM(I))
        FAIL2 = AIMAG(AMEM(I))
*
        IFAIL1 = INT(FAIL1)
        IFAIL2 = INT(FAIL2)
*
        J = J + 1
*
        PRINT *, ' IFAIL(', I-IPFAIL+J-1, ')=', IFAIL1, ';'
        PRINT *, ' IFAIL(', I-IPFAIL+J, ')=', IFAIL2, ';'
        K = I + 1
    8   CONTINUE
        IF( MOD(N,2).EQ. 0 ) GO TO 9
        FAIL1 = REAL(AMEM(K))
*
        IFAIL1 = INT(FAIL1)
        PRINT *, ' IFAIL(', I-IPFAIL+J, ')=', IFAIL1, ';'
    9   CONTINUE
      END IF
*
**        WRITE( NPR, FMT = * )'   ICLUSTR'
**        WRITE( NPR, FMT = 9981 ) INT(REAL(AMEM(IPCLUSTR)))
**        WRITE( NPR, FMT = * )'   GAP'
**        WRITE( NPR, FMT = 9982 ) DBLE(REAL(AMEM(IPGAP)))
*
 9981 FORMAT( / 9I5 /)
 9982 FORMAT( / 9D10.2 //)
*
   30 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  Z (  )'
      END IF
*
 9989 FORMAT( / ' IL = ', I5, ' IU = ', I5 / )
 9991 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12,'  ORFAC = ', D20.12/)
 9990 FORMAT( / ' M = ', I5 /)
 9999 FORMAT( / ' IFAIL = ', I5 /)
 9988 FORMAT( / ' NZ = ', I5 /)
*
      IF( NAME .EQ. 'PZHEGV2' ) GOTO 19

      CALL PZLAPRNT( N, NZ, AMEM(IPZ), IZ, JZ, DESCZ, 0, 0, 'Z',
     $               NPR, AMEM( IPW ) )
      GO TO 23
*
   19 CALL PZLAPRNT( N, N, AMEM(IPZ), IZ, JZ, DESCZ, 0, 0, 'Z',
     $               NPR, AMEM( IPW ) )
      GO TO 23
*
*     
*
   23 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   ',
     $                       ' '
         WRITE(NOUT, FMT = *)' '
*
      IF( NAME .EQ. 'PZHEGV2' ) GOTO 22
         WRITE(NOUT, FMT = *) NZ, 1
         DO 21 I = 1, NZ
            WRITE( NOUT, FMT = * ) W( I )
   21    CONTINUE
      GO TO 28
*
   22    WRITE(NOUT, FMT = *) N, 1
         DO 27 I = 1, N
            WRITE( NOUT, FMT = * ) W( I )
   27    CONTINUE
*
   28    WRITE(NOUT, FMT = *)' '
      END IF
*
      IF( NAME .EQ. 'PZHEGV2' ) GOTO 25
*
      CALL PZLAWRITE( OUTFILE, N, NZ, AMEM(IPZ), 1, 1, DESCZ,
     $                0, 0, AMEM(IPW) )
      GO TO 10
*
   25 CALL PZLAWRITE( OUTFILE, N, N, AMEM(IPZ), 1, 1, DESCZ,
     $                0, 0, AMEM(IPW) )
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'     ,',//,
     $       '  A  B -   ',I2,'  ',I2,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( /'  INFO =', I6,'  UPLO  = ',A1,'  IBTYPE = ',I1)
* 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
